{
    "$graph": [
        {
            "class": "CommandLineTool",
            "hints": [
                {
                    "dockerPull": "aplbrain/boss-access:latest",
                    "class": "DockerRequirement"
                }
            ],
            "baseCommand": "python",
            "arguments": [
                "/app/boss_access.py",
                "pull"
            ],
            "inputs": [
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 6,
                        "prefix": "--chan"
                    },
                    "id": "#boss_pull_nos3.cwl/chan_name"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 4,
                        "prefix": "--coll"
                    },
                    "id": "#boss_pull_nos3.cwl/coll_name"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 7,
                        "prefix": "--coord"
                    },
                    "id": "#boss_pull_nos3.cwl/coord_name"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 7,
                        "prefix": "--dtype"
                    },
                    "id": "#boss_pull_nos3.cwl/dtype_name"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 5,
                        "prefix": "--exp"
                    },
                    "id": "#boss_pull_nos3.cwl/exp_name"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 19,
                        "prefix": "--host"
                    },
                    "id": "#boss_pull_nos3.cwl/host_name"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 8,
                        "prefix": "--itype"
                    },
                    "id": "#boss_pull_nos3.cwl/itype_name"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 18,
                        "prefix": "--output"
                    },
                    "id": "#boss_pull_nos3.cwl/output_name"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "--padding",
                        "position": 16
                    },
                    "id": "#boss_pull_nos3.cwl/padding"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "--res",
                        "position": 9
                    },
                    "id": "#boss_pull_nos3.cwl/resolution"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 3,
                        "prefix": "--token"
                    },
                    "id": "#boss_pull_nos3.cwl/token"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "--xmax",
                        "position": 11
                    },
                    "id": "#boss_pull_nos3.cwl/xmax"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "--xmin",
                        "position": 10
                    },
                    "id": "#boss_pull_nos3.cwl/xmin"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "--ymax",
                        "position": 13
                    },
                    "id": "#boss_pull_nos3.cwl/ymax"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "--ymin",
                        "position": 12
                    },
                    "id": "#boss_pull_nos3.cwl/ymin"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "--zmax",
                        "position": 15
                    },
                    "id": "#boss_pull_nos3.cwl/zmax"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "--zmin",
                        "position": 14
                    },
                    "id": "#boss_pull_nos3.cwl/zmin"
                }
            ],
            "id": "#boss_pull_nos3.cwl",
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_name)"
                    },
                    "id": "#boss_pull_nos3.cwl/pull_output"
                }
            ]
        },
        {
            "class": "Workflow",
            "doc": "local",
            "inputs": [
                {
                    "type": "string",
                    "id": "#main/bound_start"
                },
                {
                    "type": "string",
                    "id": "#main/bound_stop"
                },
                {
                    "type": "string",
                    "id": "#main/coll_name"
                },
                {
                    "type": "string",
                    "id": "#main/coord_name"
                },
                {
                    "type": "string",
                    "id": "#main/deltas"
                },
                {
                    "type": "string",
                    "id": "#main/depth"
                },
                {
                    "type": "string",
                    "id": "#main/dtype_name_in"
                },
                {
                    "type": "string",
                    "id": "#main/exp_name"
                },
                {
                    "type": "string",
                    "id": "#main/fov_size"
                },
                {
                    "type": "string",
                    "id": "#main/host_bossdb"
                },
                {
                    "type": "string",
                    "id": "#main/image_mean"
                },
                {
                    "type": "string",
                    "id": "#main/image_stddev"
                },
                {
                    "type": "string",
                    "id": "#main/in_chan_name_raw"
                },
                {
                    "type": "string",
                    "id": "#main/init_activation"
                },
                {
                    "type": "string",
                    "id": "#main/itype_name_in"
                },
                {
                    "type": "string",
                    "id": "#main/min_boundary_dist"
                },
                {
                    "type": "string",
                    "id": "#main/min_segment_size"
                },
                {
                    "type": "string",
                    "id": "#main/move_threshold"
                },
                {
                    "type": "string",
                    "id": "#main/outfile"
                },
                {
                    "type": "string",
                    "id": "#main/pad_value"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#main/padding"
                },
                {
                    "type": "string",
                    "id": "#main/pull_output_name_raw"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#main/resolution"
                },
                {
                    "type": "string",
                    "id": "#main/segment_threshold"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#main/token_bossdb"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#main/xmax"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#main/xmin"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#main/ymax"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#main/ymin"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#main/zmax"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#main/zmin"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#main/ffn_segmentation/ffn_out",
                    "id": "#main/ffn_segmentation"
                },
                {
                    "type": "File",
                    "outputSource": "#main/boss_pull_raw/pull_output",
                    "id": "#main/pull_output_raw"
                }
            ],
            "steps": [
                {
                    "run": "#boss_pull_nos3.cwl",
                    "in": [
                        {
                            "source": "#main/in_chan_name_raw",
                            "id": "#main/boss_pull_raw/chan_name"
                        },
                        {
                            "source": "#main/coll_name",
                            "id": "#main/boss_pull_raw/coll_name"
                        },
                        {
                            "source": "#main/coord_name",
                            "id": "#main/boss_pull_raw/coord_name"
                        },
                        {
                            "source": "#main/dtype_name_in",
                            "id": "#main/boss_pull_raw/dtype_name"
                        },
                        {
                            "source": "#main/exp_name",
                            "id": "#main/boss_pull_raw/exp_name"
                        },
                        {
                            "source": "#main/host_bossdb",
                            "id": "#main/boss_pull_raw/host_name"
                        },
                        {
                            "source": "#main/itype_name_in",
                            "id": "#main/boss_pull_raw/itype_name"
                        },
                        {
                            "source": "#main/pull_output_name_raw",
                            "id": "#main/boss_pull_raw/output_name"
                        },
                        {
                            "source": "#main/padding",
                            "id": "#main/boss_pull_raw/padding"
                        },
                        {
                            "source": "#main/resolution",
                            "id": "#main/boss_pull_raw/resolution"
                        },
                        {
                            "source": "#main/token_bossdb",
                            "id": "#main/boss_pull_raw/token"
                        },
                        {
                            "source": "#main/xmax",
                            "id": "#main/boss_pull_raw/xmax"
                        },
                        {
                            "source": "#main/xmin",
                            "id": "#main/boss_pull_raw/xmin"
                        },
                        {
                            "source": "#main/ymax",
                            "id": "#main/boss_pull_raw/ymax"
                        },
                        {
                            "source": "#main/ymin",
                            "id": "#main/boss_pull_raw/ymin"
                        },
                        {
                            "source": "#main/zmax",
                            "id": "#main/boss_pull_raw/zmax"
                        },
                        {
                            "source": "#main/zmin",
                            "id": "#main/boss_pull_raw/zmin"
                        }
                    ],
                    "hints": [
                        {
                            "local": true,
                            "file_path": "/home/ubuntu/saber/volumes/data/local",
                            "class": "https://raw.githubusercontent.com/aplbrain/saber/d370ce1afd6b25be764b35069262fa23bc8f9974/saber/i2g/examples/I2G_FFN/saber"
                        }
                    ],
                    "out": [
                        "#main/boss_pull_raw/pull_output"
                    ],
                    "id": "#main/boss_pull_raw"
                },
                {
                    "$import": "#main/ffn_segmentation"
                }
            ],
            "id": "#main"
        },
        {
            "class": "CommandLineTool",
            "hints": [
                {
                    "dockerPull": "aplbrain/ffn-inference",
                    "class": "DockerRequirement"
                }
            ],
            "baseCommand": "python",
            "arguments": [
                "driver.py"
            ],
            "inputs": [
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 13,
                        "prefix": "--bound_start"
                    },
                    "id": "#ffn_segmentation.cwl/bound_start"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 14,
                        "prefix": "--bound_stop"
                    },
                    "id": "#ffn_segmentation.cwl/bound_stop"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 6,
                        "prefix": "--deltas"
                    },
                    "id": "#ffn_segmentation.cwl/deltas"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 4,
                        "prefix": "--depth"
                    },
                    "id": "#ffn_segmentation.cwl/depth"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 5,
                        "prefix": "--fov_size"
                    },
                    "id": "#ffn_segmentation.cwl/fov_size"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 2,
                        "prefix": "--image_mean"
                    },
                    "id": "#ffn_segmentation.cwl/image_mean"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 3,
                        "prefix": "--image_stddev"
                    },
                    "id": "#ffn_segmentation.cwl/image_stddev"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 7,
                        "prefix": "--init_activation"
                    },
                    "id": "#ffn_segmentation.cwl/init_activation"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--input_file"
                    },
                    "id": "#ffn_segmentation.cwl/input"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 10,
                        "prefix": "--min_boundary_dist"
                    },
                    "id": "#ffn_segmentation.cwl/min_boundary_dist"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 12,
                        "prefix": "--min_segment_size"
                    },
                    "id": "#ffn_segmentation.cwl/min_segment_size"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 9,
                        "prefix": "--move_threshold"
                    },
                    "id": "#ffn_segmentation.cwl/move_threshold"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 15,
                        "prefix": "--outfile"
                    },
                    "id": "#ffn_segmentation.cwl/outfile"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 8,
                        "prefix": "--pad_value"
                    },
                    "id": "#ffn_segmentation.cwl/pad_value"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 11,
                        "prefix": "--segment_threshold"
                    },
                    "id": "#ffn_segmentation.cwl/segment_threshold"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.outfile)"
                    },
                    "id": "#ffn_segmentation.cwl/ffn_out"
                }
            ],
            "id": "#ffn_segmentation.cwl"
        }
    ],
    "cwlVersion": "v1.0"
}
